Index: uspace/srv/net/nil/eth/eth.c
===================================================================
--- uspace/srv/net/nil/eth/eth.c	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/srv/net/nil/eth/eth.c	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -48,5 +48,4 @@
 #include <ipc/net.h>
 #include <ipc/services.h>
-#include <loc.h>
 #include <net/modules.h>
 #include <net_checksum.h>
@@ -170,8 +169,5 @@
 INT_MAP_IMPLEMENT(eth_protos, eth_proto_t);
 
-static void eth_nic_cb_connection(ipc_callid_t iid, ipc_call_t *icall,
-    void *arg);
-
-static int eth_device_state(eth_device_t *device, sysarg_t state)
+int nil_device_state_msg_local(nic_device_id_t device_id, sysarg_t state)
 {
 	int index;
@@ -183,6 +179,6 @@
 		proto = eth_protos_get_index(&eth_globals.protos, index);
 		if ((proto) && (proto->sess)) {
-			il_device_state_msg(proto->sess, device->device_id,
-			    state, proto->service);
+			il_device_state_msg(proto->sess, device_id, state,
+			    proto->service);
 		}
 	}
@@ -230,5 +226,5 @@
  *
  * @param[in] device_id New device identifier.
- * @param[in] sid       NIC service ID.
+ * @param[in] handle    Device driver handle.
  * @param[in] mtu       Device maximum transmission unit.
  *
@@ -238,5 +234,5 @@
  *
  */
-static int eth_device_message(nic_device_id_t device_id, service_id_t sid,
+static int eth_device_message(nic_device_id_t device_id, devman_handle_t handle,
     size_t mtu)
 {
@@ -263,5 +259,5 @@
 	device = eth_devices_find(&eth_globals.devices, device_id);
 	if (device) {
-		if (device->sid != sid) {
+		if (device->handle != handle) {
 			printf("Device %d already exists\n", device->device_id);
 			fibril_rwlock_write_unlock(&eth_globals.devices_lock);
@@ -302,5 +298,5 @@
 
 	device->device_id = device_id;
-	device->sid = sid;
+	device->handle = handle;
 	device->flags = 0;
 	if ((mtu > 0) && (mtu <= ETH_MAX_TAGGED_CONTENT(device->flags)))
@@ -339,5 +335,5 @@
 	
 	/* Bind the device driver */
-	device->sess = loc_service_connect(EXCHANGE_SERIALIZE, sid,
+	device->sess = devman_device_connect(EXCHANGE_SERIALIZE, handle,
 	    IPC_FLAG_BLOCKING);
 	if (device->sess == NULL) {
@@ -347,11 +343,5 @@
 	}
 	
-	rc = nic_callback_create(device->sess, eth_nic_cb_connection, device);
-	if (rc != EOK) {
-		fibril_rwlock_write_unlock(&eth_globals.devices_lock);
-		async_hangup(device->sess);
-		free(device);
-		return EIO;
-	}
+	nic_connect_to_nil(device->sess, SERVICE_ETHERNET, device_id);
 	
 	/* Get hardware address */
@@ -372,7 +362,7 @@
 	}
 	
-	printf("%s: Device registered (id: %d, sid: %zu: mtu: %zu, "
+	printf("%s: Device registered (id: %d, handle: %zu: mtu: %zu, "
 	    "mac: " PRIMAC ", flags: 0x%x)\n", NAME,
-	    device->device_id, device->sid, device->mtu,
+	    device->device_id, device->handle, device->mtu,
 	    ARGSMAC(device->addr.address), device->flags);
 
@@ -824,28 +814,5 @@
 }
 
-static int eth_received(eth_device_t *device)
-{
-	void *data;
-	size_t size;
-	int rc;
-	
-	rc = async_data_write_accept(&data, false, 0, 0, 0, &size);
-	if (rc != EOK) {
-		printf("%s: data_write_accept() failed\n", NAME);
-		return rc;
-	}
-	
-	packet_t *packet = packet_get_1_remote(eth_globals.net_sess, size);
-	if (packet == NULL)
-		return ENOMEM;
-	
-	void *pdata = packet_suffix(packet, size);
-	memcpy(pdata, data, size);
-	free(data);
-	
-	return nil_received_msg_local(device->device_id, packet);
-}
-
-static int eth_addr_changed(eth_device_t *device)
+static int eth_addr_changed(nic_device_id_t device_id)
 {
 	nic_address_t address;
@@ -865,24 +832,28 @@
 
 	fibril_rwlock_write_lock(&eth_globals.devices_lock);
-
-	printf("Device %d changing address from " PRIMAC " to " PRIMAC "\n",
-		device->device_id, ARGSMAC(device->addr.address),
-		ARGSMAC(address.address));
-	memcpy(&device->addr, &address, sizeof (nic_address_t));
-	fibril_rwlock_write_unlock(&eth_globals.devices_lock);
-
-	/* Notify all upper layer modules */
-	fibril_rwlock_read_lock(&eth_globals.protos_lock);
-	int index;
-	for (index = 0; index < eth_protos_count(&eth_globals.protos); index++) {
-		eth_proto_t *proto = eth_protos_get_index(&eth_globals.protos, index);
-		if (proto->sess != NULL) {
-			il_addr_changed_msg(proto->sess, device->device_id,
-					ETH_ADDR, address.address);
-		}
-	}
-
-	fibril_rwlock_read_unlock(&eth_globals.protos_lock);
-	return EOK;
+	/* An existing device? */
+	eth_device_t *device = eth_devices_find(&eth_globals.devices, device_id);
+	if (device) {
+		printf("Device %d changing address from " PRIMAC " to " PRIMAC "\n",
+			device_id, ARGSMAC(device->addr.address), ARGSMAC(address.address));
+		memcpy(&device->addr, &address, sizeof (nic_address_t));
+		fibril_rwlock_write_unlock(&eth_globals.devices_lock);
+
+		/* Notify all upper layer modules */
+		fibril_rwlock_read_lock(&eth_globals.protos_lock);
+		int index;
+		for (index = 0; index < eth_protos_count(&eth_globals.protos); index++) {
+			eth_proto_t *proto = eth_protos_get_index(&eth_globals.protos, index);
+			if (proto->sess != NULL) {
+				il_addr_changed_msg(proto->sess, device->device_id,
+						ETH_ADDR, address.address);
+			}
+		}
+
+		fibril_rwlock_read_unlock(&eth_globals.protos_lock);
+		return EOK;
+	} else {
+		return ENOENT;
+	}
 }
 
@@ -950,40 +921,23 @@
 		
 		return EOK;
+	case NET_NIL_DEVICE_STATE:
+		nil_device_state_msg_local(IPC_GET_DEVICE(*call), IPC_GET_STATE(*call));
+		async_answer_0(callid, EOK);
+		return EOK;
+	case NET_NIL_RECEIVED:
+		rc = packet_translate_remote(eth_globals.net_sess, &packet,
+		    IPC_GET_ARG2(*call));
+		if (rc == EOK)
+			rc = nil_received_msg_local(IPC_GET_ARG1(*call), packet);
+		
+		async_answer_0(callid, (sysarg_t) rc);
+		return rc;
+	case NET_NIL_ADDR_CHANGED:
+		rc = eth_addr_changed(IPC_GET_DEVICE(*call));
+		async_answer_0(callid, (sysarg_t) rc);
+		return rc;
 	}
 	
 	return ENOTSUP;
-}
-
-static void eth_nic_cb_connection(ipc_callid_t iid, ipc_call_t *icall, void *arg)
-{
-	eth_device_t *device = (eth_device_t *)arg;
-	int rc;
-	
-	async_answer_0(iid, EOK);
-	
-	while (true) {
-		ipc_call_t call;
-		ipc_callid_t callid = async_get_call(&call);
-		
-		if (!IPC_GET_IMETHOD(call))
-			break;
-		
-		switch (IPC_GET_IMETHOD(call)) {
-		case NIC_EV_DEVICE_STATE:
-			rc = eth_device_state(device, IPC_GET_ARG1(call));
-			async_answer_0(callid, (sysarg_t) rc);
-			break;
-		case NIC_EV_RECEIVED:
-			rc = eth_received(device);
-			async_answer_0(callid, (sysarg_t) rc);
-			break;
-		case NIC_EV_ADDR_CHANGED:
-			rc = eth_addr_changed(device);
-			async_answer_0(callid, (sysarg_t) rc);
-			break;
-		default:
-			async_answer_0(callid, ENOTSUP);
-		}
-	}
 }
 
Index: uspace/srv/net/nil/eth/eth.h
===================================================================
--- uspace/srv/net/nil/eth/eth.h	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/srv/net/nil/eth/eth.h	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -41,8 +41,8 @@
 #include <async.h>
 #include <fibril_synch.h>
-#include <ipc/loc.h>
 #include <ipc/services.h>
 #include <net/device.h>
 #include <adt/measured_strings.h>
+#include <devman.h>
 
 /** Ethernet address length. */
@@ -224,5 +224,5 @@
 	nic_device_id_t device_id;
 	/** Device handle */
-	service_id_t sid;
+	devman_handle_t handle;
 	/** Driver session. */
 	async_sess_t *sess;
Index: uspace/srv/net/nil/nildummy/nildummy.c
===================================================================
--- uspace/srv/net/nil/nildummy/nildummy.c	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/srv/net/nil/nildummy/nildummy.c	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -2,5 +2,4 @@
  * Copyright (c) 2009 Lukas Mejdrech
  * Copyright (c) 2011 Radim Vansa
- * Copyright (c) 2011 Jiri Svoboda
  * All rights reserved.
  *
@@ -54,6 +53,6 @@
 #include <packet_remote.h>
 #include <packet_client.h>
+#include <devman.h>
 #include <device/nic.h>
-#include <loc.h>
 #include <nil_skel.h>
 #include "nildummy.h"
@@ -70,21 +69,13 @@
 DEVICE_MAP_IMPLEMENT(nildummy_devices, nildummy_device_t);
 
-static void nildummy_nic_cb_conn(ipc_callid_t iid, ipc_call_t *icall,
-    void *arg);
-
-static int nildummy_device_state(nildummy_device_t *device, sysarg_t state)
+int nil_device_state_msg_local(nic_device_id_t device_id, sysarg_t state)
 {
 	fibril_rwlock_read_lock(&nildummy_globals.protos_lock);
 	if (nildummy_globals.proto.sess)
-		il_device_state_msg(nildummy_globals.proto.sess,
-		    device->device_id, state, nildummy_globals.proto.service);
+		il_device_state_msg(nildummy_globals.proto.sess, device_id,
+		    state, nildummy_globals.proto.service);
 	fibril_rwlock_read_unlock(&nildummy_globals.protos_lock);
 	
 	return EOK;
-}
-
-static int nildummy_addr_changed(nildummy_device_t *device)
-{
-	return ENOTSUP;
 }
 
@@ -124,5 +115,5 @@
  */
 static int nildummy_device_message(nic_device_id_t device_id,
-    service_id_t sid, size_t mtu)
+    devman_handle_t handle, size_t mtu)
 {
 	fibril_rwlock_write_lock(&nildummy_globals.devices_lock);
@@ -132,5 +123,5 @@
 	    nildummy_devices_find(&nildummy_globals.devices, device_id);
 	if (device) {
-		if (device->sid != sid) {
+		if (device->handle != handle) {
 			printf("Device %d exists, handles do not match\n",
 			    device->device_id);
@@ -167,5 +158,5 @@
 	
 	device->device_id = device_id;
-	device->sid = sid;
+	device->handle = handle;
 	if (mtu > 0)
 		device->mtu = mtu;
@@ -174,5 +165,5 @@
 	
 	/* Bind the device driver */
-	device->sess = loc_service_connect(EXCHANGE_SERIALIZE, sid,
+	device->sess = devman_device_connect(EXCHANGE_SERIALIZE, handle,
 	    IPC_FLAG_BLOCKING);
 	if (device->sess == NULL) {
@@ -182,14 +173,8 @@
 	}
 	
-	int rc = nic_callback_create(device->sess, nildummy_nic_cb_conn,
-	    device);
-	if (rc != EOK) {
-		async_hangup(device->sess);
-		
-		return ENOENT;
-	}
+	nic_connect_to_nil(device->sess, SERVICE_NILDUMMY, device_id);
 	
 	/* Get hardware address */
-	rc = nic_get_address(device->sess, &device->addr);
+	int rc = nic_get_address(device->sess, &device->addr);
 	if (rc != EOK) {
 		fibril_rwlock_write_unlock(&nildummy_globals.devices_lock);
@@ -360,4 +345,6 @@
     services_t sender)
 {
+	packet_t *p;
+	
 	fibril_rwlock_read_lock(&nildummy_globals.devices_lock);
 	
@@ -369,5 +356,5 @@
 	}
 	
-	packet_t *p = packet;
+	p = packet;
 	do {
 		nic_send_frame(device->sess, packet_get_data(p),
@@ -381,25 +368,4 @@
 	
 	return EOK;
-}
-
-static int nildummy_received(nildummy_device_t *device)
-{
-	void *data;
-	size_t size;
-	int rc;
-
-	rc = async_data_write_accept(&data, false, 0, 0, 0, &size);
-	if (rc != EOK)
-		return rc;
-
-	packet_t *packet = packet_get_1_remote(nildummy_globals.net_sess, size);
-	if (packet == NULL)
-		return ENOMEM;
-
-	void *pdata = packet_suffix(packet, size);
-	memcpy(pdata, data, size);
-	free(pdata);
-
-	return nil_received_msg_local(device->device_id, packet);
 }
 
@@ -458,42 +424,22 @@
 		*answer_count = 1;
 		return rc;
+	case NET_NIL_DEVICE_STATE:
+		rc = nil_device_state_msg_local(IPC_GET_DEVICE(*call),
+		    IPC_GET_STATE(*call));
+		async_answer_0(callid, (sysarg_t) rc);
+		return rc;
+	
+	case NET_NIL_RECEIVED:
+		rc = packet_translate_remote(nildummy_globals.net_sess, &packet,
+		    IPC_GET_ARG2(*call));
+		if (rc == EOK)
+			rc = nil_received_msg_local(IPC_GET_ARG1(*call), packet);
+		
+		async_answer_0(callid, (sysarg_t) rc);
+		return rc;
 	}
 	
 	return ENOTSUP;
 }
-
-static void nildummy_nic_cb_conn(ipc_callid_t iid, ipc_call_t *icall, void *arg)
-{
-	nildummy_device_t *device = (nildummy_device_t *)arg;
-	int rc;
-	
-	async_answer_0(iid, EOK);
-	
-	while (true) {
-		ipc_call_t call;
-		ipc_callid_t callid = async_get_call(&call);
-		
-		if (!IPC_GET_IMETHOD(call))
-			break;
-		
-		switch (IPC_GET_IMETHOD(call)) {
-		case NIC_EV_DEVICE_STATE:
-			rc = nildummy_device_state(device, IPC_GET_ARG1(call));
-			async_answer_0(callid, (sysarg_t) rc);
-			break;
-		case NIC_EV_RECEIVED:
-			rc = nildummy_received(device);
-			async_answer_0(callid, (sysarg_t) rc);
-			break;
-		case NIC_EV_ADDR_CHANGED:
-			rc = nildummy_addr_changed(device);
-			async_answer_0(callid, (sysarg_t) rc);
-			break;
-		default:
-			async_answer_0(callid, ENOTSUP);
-		}
-	}
-}
-
 
 int main(int argc, char *argv[])
Index: uspace/srv/net/nil/nildummy/nildummy.h
===================================================================
--- uspace/srv/net/nil/nildummy/nildummy.h	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/srv/net/nil/nildummy/nildummy.h	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -41,6 +41,6 @@
 #include <async.h>
 #include <fibril_synch.h>
-#include <ipc/loc.h>
 #include <ipc/services.h>
+#include <ipc/devman.h>
 #include <net/device.h>
 
@@ -78,6 +78,6 @@
 	/** Device identifier. */
 	nic_device_id_t device_id;
-	/** Device service ID. */
-	service_id_t sid;
+	/** Device driver handle. */
+	devman_handle_t handle;
 	/** Driver session. */
 	async_sess_t *sess;
